! create following JSON string:
!
!  { 
!    "name": "Jack (\"Bee\") Nimble", 
!    "format": { 
!      "type": "rect", 
!      "width": 1920, 
!      "height": 1080, 
!      "interlace": false, 
!      "frame rate": 24 
!    }, 
!    "days of week": ["Monday",  "Tuesday",  "Wednesday",  "Thursday",  "Friday",  "Saturday",  "Sunday"] 
!  }

!{
!    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
!    "cashier_name": "string",
!    "departament": "string",
!    "goods": [{
!            "good": {
!                "code": "string",
!                "name": "string",
!                "barcode": "string",
!                "excise_barcode": "string",
!                "excise_barcodes": ["string"],
!                "header": "string",
!                "footer": "string",
!                "price": 0,
!                "tax": [0],
!                "uktzed": "string"
!            },
!            "good_id": "d02efc8a-7305-44cc-a4d1-d1cdc667a623",
!            "quantity": 0,
!            "is_return": false,
!            "discounts": []
!        }
!    ],
!    "delivery": {
!        "email": "user@example.com",
!        "emails": ["user@example.com"],
!        "phone": "string"
!    },
!    "discounts": [],
!    "payments": [],
!    "rounding": false,
!    "header": "string",
!    "footer": "string",
!    "barcode": "string",
!    "order_id": "93101167-9065-4b9c-b98b-5d789a3ed9fe",
!    "related_receipt_id": "d903f598-5263-4705-9a2a-fe57ee4b2b3a",
!    "previous_receipt_id": "6baa5594-09b6-4656-b083-9032975dfaa0",
!    "technical_return": false,
!    "context": {
!        "property1": "string",
!        "property2": "string"
!    },
!    "is_pawnshop": false
!}



  PROGRAM
  INCLUDE('cjson.inc')
  MAP
    CreateJSON()
  END

  CODE

  CreateJSON()

CreateJSON                    PROCEDURE()
root	    &cJSON  !root object
gd          &cJSON  !root object
gds         &cJSON  !root object
deliv       &cJSON  !root object
tax	        &cJSON  !root object

good            GROUP               ! \
ucode               STRING(50), NAME('code')      !  \
name                STRING(255)     !  \
barcode             STRING(100)     !  \
excise_barcode      STRING(4096)    !    \
excise_barcodes     STRING(100)            
header              STRING(1000)    !    \
footer              STRING(1000)    !   \
price               LONG            !  \,   .  454 ,  45400
!tax                 &QUEUE   
uktzed              STRING(255)
                END

goods                               QUEUE            !  \:
good_id             STRING(50)      ! \
quantity            LONG
is_return           BOOL                   
discounts           STRING(100)
                END

discounts       QUEUE
type                STRING(20)      !    , DISCOUNT - , EXTRA_CHARGE - 
mode                STRING(20)      !  , PERCENT - , VALUE - 
value               LONG            !                      
tax_code            STRING(20)      !    .  1  
tax_codes           STRING(100)     !    .
                END

delivery       GROUP
email       STRING(40)              ! "user@example.com",
emails      STRING(255)             ! ["user@example.com","user2@example.com","user3@example.com"],
phone       STRING(100)             ! "string"
                END
context       GROUP
property1      STRING(255)       
property2      STRING(255)      
                END

payments        QUEUE
type                STRING(20), DIM(2)
value               LONG
label               STRING(100)                   
                END

taxQ        Queue
type                STRING(20)
value               LONG
label               STRING(100)                   
                END
qIndex                          LONG, AUTO

    CODE
        
    DO load_goods
    DO load_payments       
        
    gd &= json::CreateObject()
    gd.AddItemToObject('code', json::CreateString('string'))    
    gd.AddItemToObject('name', json::CreateString('string'))    
    gd.AddItemToObject('barcode', json::CreateString('string'))    
    gd.AddItemToObject('excise_barcode', json::CreateString('string'))    
    gd.AddItemToObject('excise_barcodes', json::CreateString('string'))    
    gd.AddItemToObject('header', json::CreateString('string'))    
    gd.AddItemToObject('footer', json::CreateString('string'))    
    gd.AddItemToObject('price', json::CreateString('string'))    
    gd.AddItemToObject('tax', json::CreateArray(taxQ))
        
    gds &= json::CreateObject()
!    Loop i# = 1 TO RECORDS(goods)       ! 
!        GET(goods,i#)
        gds.AddItemToObject('good', gd)    
        gds.AddItemToObject('good_id', json::CreateString(goods.good_id))    
        gds.AddItemToObject('quantity', json::CreateNumber(goods.quantity))    
        gds.AddItemToObject('is_return', json::CreateFalse())    
        gds.AddItemToObject('discounts', json::CreateArray(discounts))

!        MESSAGE('1: '& gds.ToString(TRUE))
!    END

    !create root object
    root &= json::CreateObject()
    !add a string to root
    root.AddItemToObject('id', json::CreateString('497f6eca-6276-4993-bfeb-53cbbbba6f08'))
    root.AddItemToObject('cashier_name', json::CreateString('string'))
    root.AddItemToObject('departament', json::CreateString('string'))
    root.AddItemToObject('goods', json::CreateArrayReference(gds))
    root.AddItemToObject('delivery', json::CreateObject(delivery))
    root.AddItemToObject('discounts', json::CreateArray(discounts))
    root.AddItemToObject('payments', json::CreateArray(payments))
    root.AddItemToObject('rounding', json::CreateFalse())
    root.AddItemToObject('header', json::CreateString('string'))
    root.AddItemToObject('footer', json::CreateString('string'))
    root.AddItemToObject('barcode', json::CreateString('string'))
    root.AddItemToObject('order_id', json::CreateString('93101167-9065-4b9c-b98b-5d789a3ed9fe'))
    root.AddItemToObject('related_receipt_id', json::CreateString('d903f598-5263-4705-9a2a-fe57ee4b2b3a'))
    root.AddItemToObject('previous_receipt_id', json::CreateString('6baa5594-09b6-4656-b083-9032975dfaa0'))
    root.AddItemToObject('technical_return', json::CreateFalse())
    root.AddItemToObject('context', json::CreateObject(context))
    root.AddItemToObject('is_pawnshop', json::CreateFalse())
     
    !json::DebugInfo(root.ToString(TRUE))
    MESSAGE(root.ToString(TRUE))
    
    !dispose all cJSON objects at once
    root.Delete()
        
load_goods          ROUTINE
    
    CLEAR(goods)
!    goods.good.tax = Tax::Inst
    goods.good_id   = 'd02efc8a-7305-44cc-a4d1-d1cdc667a623'
    goods.quantity  = 10  
    goods.is_return = 0 
    goods.discounts = '[555]'
    ADD(goods)
        
    CLEAR(goods)
    goods.good_id   = 'aaaaaaaa-7305-44cc-a4d1-d1cdc667a623'
    goods.quantity  = 10  
    goods.is_return = 0 
    goods.discounts = '[123]'
    ADD(goods)      
        
    EXIT

load_tax          ROUTINE
    
!    CLEAR(tax)
!    good.good_id   = 'd02efc8a-7305-44cc-a4d1-d1cdc667a623'
!    goods.quantity  = 0  
!    goods.is_return = 1 
!    goods.discounts = '[555]'
!    ADD(goods)
!        
!    CLEAR(goods)
!    goods.good_id   = 'aaaaaaaa-7305-44cc-a4d1-d1cdc667a623'
!    goods.quantity  = 0  
!    goods.is_return = 0 
!    goods.discounts = '[123]'
!    ADD(goods)      
        
    EXIT
    
load_payments       ROUTINE
    ! 3   )  ) )  + 
    
    CLEAR(payments)
    payments.type[1] = 'CASH'   !  , CASH- , CASHLESS -( ,    ..)
    payments.value   = 0        !  ,   
    payments.label   = ''       !             
    ADD(payments)      
        
    EXIT


!  strings[1] = 'Monday'
!  strings[2] = 'Tuesday'
!  strings[3] = 'Wednesday'
!  strings[4] = 'Thursday'
!  strings[5] = 'Friday'
!  strings[6] = 'Saturday'
!  strings[7] = 'Sunday'
!  
!  !create format object
!  fmt &= json::CreateObject()
!  fmt.AddStringToObject('type', 'rect')
!  fmt.AddNumberToObject('width', 1920)  
!  fmt.AddNumberToObject('height', 1080)  
!  fmt.AddFalseToObject('interlace')
!  fmt.AddNumberToObject('frame rate', 24)
!  
!  !create days of week array
!  dow &= json::CreateStringArray(strings)
!  
!  !create root object
!  root &= json::CreateObject()
!  
!  !add a string to root
!  root.AddItemToObject('name', json::CreateString('Jack ("Bee") Nimble'))
!  
!  !add format object to root
!  root.AddItemToObject('format', fmt)
!
!  !add days array to root
!  root.AddItemToObject('days of week', dow)
!  
!  !json::DebugInfo(root.ToString(TRUE))
!  MESSAGE(root.ToString(TRUE))
!  
!  !dispose all cJSON objects at once
!  root.Delete()
